<?php
/* ----------------------------------------------------------------------------------
 *
 * Xaseco plugin paying coppers to players earning one of the first three records.
 *
 * New record payment is only valued:
 * - if there was a record before (not new track)
 * - if the login differs from the existing record
 * - for the last player who earns the record
 *
 * the payment is only at rounds end. If the track is new there have to be at least two players to get any payment
 *
 * ----------------------------------------------------------------------------------
 *
 * Author: 			ML aka RookieNouse aka nouseforname @ http://www.tm-forum.com
 * Home: 			http://tmf.game-host.org
 * Date: 			21.12.2009
 * Version:			1.0a
 * Dependencies: 	none
 *
 * ----------------------------------------------------------------------------------
 *
 * LICENSE: This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 *
 * ----------------------------------------------------------------------------------
 */

class NousePayRecords {

/* ===================  config start ========================== */

	private $coppers_pos1 = 50, 	// payment for first record
			$coppers_pos2 = 40,		// payment for second record
			$coppers_pos3 = 30,		// payment for thirs record
			$coppers_pos4 = 20,
			$coppers_pos5 = 15;
			
	private $minservercoppers = 1000; // minimum coppers amount to activate payment
	private $minrecs = 20; // minimum records count

	private $chatmessage = true; // true activates a chatmessage at rounds end, with information about winners
	
/* ===================  config end ========================== */

	var $winner1 = array();
	var $winner2 = array();
	var $winner3 = array();
	var $winner4 = array();
	var $winner5 = array();
	var $rec1 =array();
	var $rec2 =array();
	var $rec3 =array();
	var $rec4 =array();
	var $rec5 =array();
	private $limit, $mode;
	
	
	// on begin round
	function reset_state($aseco) {
	
		$this->winner1 = array();
		$this->winner2 = array();
		$this->winner3 = array();
		$this->winner4 = array();
		$this->winner5 = array();
		
		if ($aseco->server->getGame() == 'TMF') {
			// check for TMUF server
			if ($aseco->server->rights) {		
				$aseco->client->query('GetServerCoppers');
				$coppers = $aseco->client->getResponse();
				$this->mode = $aseco->server->gameinfo->mode;
			} else {
				$message = formatText($aseco->getChatMessage('UNITED_ONLY'), 'server');
				$this->Aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
			}
		} else {
			$message = $aseco->getChatMessage('FOREVER_ONLY');
			$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
		}
		
		// proceed only if enough coppers
		if ($coppers >= $this->minservercoppers) {
			$this->limit = true;
		} else {
			$this->limit = false;
			$message = '$ff0> $g$z$6c0$s$iLow server coppers, records payment disabled. Please donate some.';
			$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
		}
		
	}
	
	// on begin round and after getting new record
	function get_actual_records($aseco) {
		// proceed only if enough coppers
		if (!$this->limit) return;
		
		if ($aseco->server->records->count() >= $this->minrecs) {
			$record1 = $aseco->server->records->getRecord(0); // get first record	
			$nick1 = $record1->player->nickname;
			$login1 = $record1->player->login;
			$score1 = $record1->score;
			$this->rec1 = array($login1, $nick1, $score1);

			$record2 = $aseco->server->records->getRecord(1); // get first record	
			$nick2 = $record2->player->nickname;
			$login2 = $record2->player->login;
			$score2 = $record2->score;
			$this->rec2 = array($login2, $nick2, $score2);

			$record3 = $aseco->server->records->getRecord(2); // get first record	
			$nick3 = $record3->player->nickname;
			$login3 = $record3->player->login;
			$score3 = $record3->score;
			$this->rec3 = array($login3, $nick3, $score3);
			
			$record4 = $aseco->server->records->getRecord(3); 
			$nick4 = $record4->player->nickname;
			$login4 = $record4->player->login;
			$score4 = $record4->score;
			$this->rec4 = array($login4, $nick4, $score4);
			
			$record5 = $aseco->server->records->getRecord(4); 
			$nick5 = $record5->player->nickname;
			$login5 = $record5->player->login;
			$score5 = $record5->score;
			$this->rec5 = array($login5, $nick5, $score5);
		} else {
			$message= '$ff0> $g$z$6c0$s$iRecords Payment disabled due to to less records.';
			$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
		}
	}

	// on player finish
	function check_new_records($aseco, $pl_finish) {
		
		// proceed only if enough coppers
		if (!$this->limit) return;
	
		$act_score = $pl_finish->score;
		$act_login = $pl_finish->player->login;
		$act_nickname = $pl_finish->player->nickname;
		
		if (!$act_score) return;
		
		if ($this->mode != 4) {
			if (!$this->rec1) $this->rec1 = array('', '', 999999);
			if (!$this->rec2) $this->rec2 = array('', '', 999999);
			if (!$this->rec3) $this->rec3 = array('', '', 999999);
			if (!$this->rec4) $this->rec4 = array('', '', 999999);
			if (!$this->rec5) $this->rec5 = array('', '', 999999);
		} else {
			if (!$this->rec1) $this->rec1 = array('', '', -999);
			if (!$this->rec2) $this->rec2 = array('', '', -999);
			if (!$this->rec3) $this->rec3 = array('', '', -999);
			if (!$this->rec4) $this->rec4 = array('', '', -999);
			if (!$this->rec5) $this->rec5 = array('', '', -999);
		}

		if ($this->rec1[0] != false && 
			$act_login != $this->rec1[0] && 
				($this->mode == 4 ? $act_score > $this->rec1[2] : $act_score < $this->rec1[2])) {
		
			$this->rec1 = array($act_login, $act_nickname, $act_score);
			$this->winner1 = array($act_login, $act_nickname, $act_score);
			//$message = '$ff0> New first record '. $this->winner1[2] .' - '. $this->winner1[1]; 
			//$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
			
			if ($act_login == $this->rec2[0]) $this->winner2 = array();
			if ($act_login == $this->rec3[0]) $this->winner3 = array();
			if ($act_login == $this->rec4[0]) $this->winner4 = array();
			if ($act_login == $this->rec5[0]) $this->winner5 = array();
				
		} elseif ($this->rec2[0] != false && 
			$act_login != $this->rec2[0] && 
				$act_login != $this->rec1[0] && 
					($this->mode == 4 ? $act_score > $this->rec2[2] : $act_score < $this->rec2[2])) {
		
			$this->rec2 = array($act_login, $act_nickname, $act_score);
			$this->winner2 = array($act_login, $act_nickname, $act_score);
			//$message = '$ff0> New second record '. $this->winner2[2] .' - '. $this->winner2[1]; 
			//$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
			if ($act_login == $this->rec3[0]) $this->winner3 = array();
			if ($act_login == $this->rec4[0]) $this->winner4 = array();
			if ($act_login == $this->rec5[0]) $this->winner5 = array();

		} elseif ($this->rec3[0] != false && 
			$act_login != $this->rec3[0] && 
				$act_login != $this->rec2[0] && 
					$act_login != $this->rec1[0] && 
						($this->mode == 4 ? $act_score > $this->rec3[2] : $act_score < $this->rec3[2])) {

			$this->rec3 = array($act_login, $act_nickname, $act_score);
			$this->winner3 = array($act_login, $act_nickname, $act_score);
			//$message = '$ff0> New third record '. $this->winner3[2] .' - '. $this->winner3[1]; 
			//$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
			if ($act_login == $this->rec4[0]) $this->winner4 = array();
			if ($act_login == $this->rec5[0]) $this->winner5 = array();
			
		} elseif ($this->rec4[0] != false && 
			$act_login != $this->rec4[0] && 
				$act_login != $this->rec3[0] && 
					$act_login != $this->rec2[0] && 
						$act_login != $this->rec1[0] &&
							($this->mode == 4 ? $act_score > $this->rec4[2] : $act_score < $this->rec4[2])) {

			$this->rec4 = array($act_login, $act_nickname, $act_score);
			$this->winner4 = array($act_login, $act_nickname, $act_score);
			//$message = '$ff0> New fourth record '. $this->winner3[2] .' - '. $this->winner3[1]; 
			//$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
			if ($act_login == $this->rec5[0]) $this->winner5 = array();
			
		} elseif ($this->rec5[0] != false && 
			$act_login != $this->rec5[0] &&
				$act_login != $this->rec4[0] &&
					$act_login != $this->rec3[0] && 
						$act_login != $this->rec2[0] && 
							$act_login != $this->rec1[0] && 
								($this->mode == 4 ? $act_score > $this->rec5[2] : $act_score < $this->rec5[2])) {

			$this->rec5 = array($act_login, $act_nickname, $act_score);
			$this->winner5 = array($act_login, $act_nickname, $act_score);
			//$message = '$ff0> New fifth record '. $this->winner3[2] .' - '. $this->winner3[1]; 
			//$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
			
		}
		
		if (!$this->rec1[0] || !$this->rec2[0] || !$this->rec3[0] || !$this->rec4[0] || !$this->rec5[0]) $this->get_actual_records($aseco);
		if ($this->mode == 4 ? $act_score > $this->rec5[2] : $act_score < $this->rec5[2]) $this->get_actual_records($aseco);
      
	}

	function pay_coppers($aseco) {
		
		if (!$this->limit) return;
		
		if ($this->winner1[0] && $aseco->server->players->getPlayer($this->winner1[0])->rights) {
			if ($this->chatmessage) {
				$message = '$ff0> '. $this->winner1[1] .' $g$z$6c0$s$i earned the first local record and won '. $this->coppers_pos1 .' coppers.';
				$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
			}
			$message = 'You\'ve earned the first local record as last player this round. You won '. $this->coppers_pos1 .' coppers!'; 
			$aseco->client->addCall('Pay', array($this->winner1[0], $this->coppers_pos1, $aseco->formatColors($message)));
		}
		if ($this->winner2[0] && $aseco->server->players->getPlayer($this->winner2[0])->rights) {
			if ($this->chatmessage) {
				$message = '$ff0> '. $this->winner2[1] .'$g$z$6c0$s$i earned the second local record and won '. $this->coppers_pos2 .' coppers.';
				$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
			}
			$message = 'You\'ve earned the second local record as last player this round. You won '. $this->coppers_pos2 .' coppers!'; 
			$aseco->client->addCall('Pay', array($this->winner2[0], $this->coppers_pos2, $aseco->formatColors($message)));
		}
		if ($this->winner3[0] && $aseco->server->players->getPlayer($this->winner3[0])->rights) {
			if ($this->chatmessage) {
				$message = '$ff0> '. $this->winner3[1] .'$g$z$6c0$s$i earned the third local record and won '. $this->coppers_pos3 .' coppers.';
				$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
			}
			$message = 'You\'ve earned the third local record as last player this round. You won '. $this->coppers_pos3 .' coppers!'; 
			$aseco->client->addCall('Pay', array($this->winner3[0], $this->coppers_pos3, $aseco->formatColors($message)));
		}
		if ($this->winner4[0] && $aseco->server->players->getPlayer($this->winner4[0])->rights) {
			if ($this->chatmessage) {
				$message = '$ff0> '. $this->winner4[1] .'$g$z$6c0$s$i earned the fourth local record and won '. $this->coppers_pos4 .' coppers.';
				$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
			}
			$message = 'You\'ve earned the fourth local record as last player this round. You won '. $this->coppers_pos4 .' coppers!'; 
			$aseco->client->addCall('Pay', array($this->winner4[0], $this->coppers_pos4, $aseco->formatColors($message)));
		}
		if ($this->winner5[0] && $aseco->server->players->getPlayer($this->winner5[0])->rights) {
			if ($this->chatmessage) {
				$message = '$ff0> '. $this->winner5[1] .'$g$z$6c0$s$i earned the fifth local record and won '. $this->coppers_pos5 .' coppers.';
				$aseco->client->addCall('ChatSendServerMessage', array($aseco->formatColors($message)));
			}
			$message = 'You\'ve earned the fifth local record as last player this round. You won '. $this->coppers_pos5 .' coppers!'; 
			$aseco->client->addCall('Pay', array($this->winner5[0], $this->coppers_pos5, $aseco->formatColors($message)));
		}
	}
}

global $npr;
$npr = new NousePayRecords(false);

Aseco::registerEvent('onBeginRound', array($npr, 'reset_state'));
Aseco::registerEvent('onBeginRound', array($npr, 'get_actual_records'));
Aseco::registerEvent('onPlayerFinish',  array($npr, 'check_new_records'));
Aseco::registerEvent('onEndRace', array($npr, 'pay_coppers'));
	
?>